code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	near ptr init		; jump to install routine/old handler
	dw	0			; extra word to hold far jump segment

new21:	cmp	ax,4b00h		; load and execute?
	jne	start

	push	ax
	mov	ax,5800h		; get memory allocation strategy
	int	21h
	cmp	al,80h			; high then low?
	jne	done
	push	bx
	mov	ax,5801h		; set memory allocation strategy
	mov	bl,40h			; high only
	int	21h
	pop	bx
done:	pop	ax
	jmp	short start		; continue

init:	mov	ax,3521h		; create jump to old handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new21		; hook into chain
	mov	ah,25h
	int	21h

	mov	es,envseg		; free environment segment
	mov	ah,49h
	int	21h

	mov	dx,0012h		; terminate, leave DX paras resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
